
/**
 ** Generated data (by mkcproc.pl)
 **/
#line 1 "bsewaveosc.proc"

#include <bse/bseplugin.h>
#include <bse/bsewaveosc.h>
#include <bse/bseprocedure.h>
#include <bse/bseeditablesample.h>

#line 25 "bsewaveosc.proc"


/* --- request-pcm-position --- */
static GType type_id_request_pcm_position = 0;
static void
request_pcm_position_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 27 "bsewaveosc.proc"
 {
#line 29 "bsewaveosc.proc"
  *(in_pspecs++) = bse_param_spec_object ("wosc", NULL, "Wave Oscilator",
				 BSE_TYPE_WAVE_OSC, SFI_PARAM_DEFAULT);
#line 28 "bsewaveosc.proc"
  proc->help = "Request emission of the ::notify_pcm_position signal.";
#line 23 "bsewaveosc.proc"
  proc->authors = "Tim Janik <timj@gtk.org>";
#line 24 "bsewaveosc.proc"
  proc->copyright = "Copyright (C) 2002-2003 Tim Janik";
#line 31 "bsewaveosc.proc"
}  }
static BseErrorType
#line 31 "bsewaveosc.proc"
request_pcm_position_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 34 "bsewaveosc.proc"
{
#line 35 "bsewaveosc.proc"
  
  BseWaveOsc *self = bse_value_get_object (in_values++);
  
#line 38 "bsewaveosc.proc"
  
  if (!BSE_IS_WAVE_OSC (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
  
  bse_wave_osc_request_pcm_position (self, -1);
  
  return BSE_ERROR_NONE;
}

/* --- pcm-seek-perc --- */
static GType type_id_pcm_seek_perc = 0;
static void
pcm_seek_perc_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 47 "bsewaveosc.proc"
 {
#line 49 "bsewaveosc.proc"
  *(in_pspecs++) = bse_param_spec_object ("wosc", NULL, "Wave Oscilator",
				 BSE_TYPE_WAVE_OSC, SFI_PARAM_DEFAULT);
  *(in_pspecs++) = sfi_pspec_real ("pos_perc", NULL, NULL,
			  0, 0, 100, 1,
			  SFI_PARAM_DEFAULT);
#line 48 "bsewaveosc.proc"
  proc->help = "Seek oscillator to a given pcm percentage during playback.";
#line 23 "bsewaveosc.proc"
  proc->authors = "Tim Janik <timj@gtk.org>";
#line 24 "bsewaveosc.proc"
  proc->copyright = "Copyright (C) 2002-2003 Tim Janik";
#line 54 "bsewaveosc.proc"
}  }
static BseErrorType
#line 54 "bsewaveosc.proc"
pcm_seek_perc_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 57 "bsewaveosc.proc"
{
#line 58 "bsewaveosc.proc"
  
  BseWaveOsc *self = bse_value_get_object (in_values++);
  gfloat      pos  = sfi_value_get_real (in_values++);
  
#line 62 "bsewaveosc.proc"
  
  if (!BSE_IS_WAVE_OSC (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
  
  bse_wave_osc_request_pcm_position (self, CLAMP (pos, 0, 100));
  
  return BSE_ERROR_NONE;
}

/* --- set-from-editable-sample --- */
static GType type_id_set_from_editable_sample = 0;
static void
set_from_editable_sample_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 71 "bsewaveosc.proc"
 {
#line 73 "bsewaveosc.proc"
  *(in_pspecs++) = bse_param_spec_object ("wosc", NULL, "Wave Oscilator",
				 BSE_TYPE_WAVE_OSC, SFI_PARAM_DEFAULT);
  *(in_pspecs++) = bse_param_spec_object ("esample", NULL, "Editable Sample",
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_DEFAULT);
#line 72 "bsewaveosc.proc"
  proc->help = "Set wave to play from editable sample, bypassing undo and storage mechanisms.";
#line 23 "bsewaveosc.proc"
  proc->authors = "Tim Janik <timj@gtk.org>";
#line 24 "bsewaveosc.proc"
  proc->copyright = "Copyright (C) 2002-2003 Tim Janik";
#line 77 "bsewaveosc.proc"
}  }
static BseErrorType
#line 77 "bsewaveosc.proc"
set_from_editable_sample_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 80 "bsewaveosc.proc"
{
#line 81 "bsewaveosc.proc"
  
  BseWaveOsc *self           = bse_value_get_object (in_values++);
  BseEditableSample *esample = bse_value_get_object (in_values++);

#line 85 "bsewaveosc.proc"
  
  if (!BSE_IS_WAVE_OSC (self))
    return BSE_ERROR_PROC_PARAM_INVAL;
  
  bse_wave_osc_set_from_esample (self, esample);
  
  return BSE_ERROR_NONE;
}

/* --- Export to BSE --- */
BSE_EXPORTS_BEGIN (BSE_PLUGIN_NAME);
BSE_EXPORT_PROCEDURES = {
  { &type_id_request_pcm_position, "BseWaveOsc+request-pcm-position", NULL, 0, request_pcm_position_setup, request_pcm_position_exec, NULL, "/Method/BseWaveOsc/General/Request Pcm Position", { 0, }, },
  { &type_id_pcm_seek_perc, "BseWaveOsc+pcm-seek-perc", NULL, 0, pcm_seek_perc_setup, pcm_seek_perc_exec, NULL, "/Method/BseWaveOsc/General/Pcm Seek Perc", { 0, }, },
  { &type_id_set_from_editable_sample, "BseWaveOsc+set-from-editable-sample", NULL, 0, set_from_editable_sample_setup, set_from_editable_sample_exec, NULL, "/Method/BseWaveOsc/General/Set From Editable Sample", { 0, }, },
  { NULL, },
};
BSE_EXPORTS_END;

/**
 ** Generated data ends here
 **/
